def totalSelectedValues(list : List[Int], 
  selector : Int => Boolean) = {

  var total = 0
  for(e <- list) {
    if (selector(e)) total += e
  }
  total
} 

val lst = List(1, 4, 5, 6)
println(totalSelectedValues(lst, { e => true }))

println(totalSelectedValues(lst, { e => e % 2 == 0 }))

println(totalSelectedValues(lst, {e => e > 2 }))

println(lst.filter { 
  e => e > 2 }.reduceLeft { (c, e) => c + e })