def doubleImperative(list: List[Int]) = {
  var doubled : List[Int] = List()
  
  for(e <- list) {
    doubled = doubled ::: List(e * 2)
  }
  doubled
}

def doubleFunctional(list: List[Int]) = {
  list.map { e => e * 2 }
}

val lst = List(4, 7, 2, 3)

println(doubleImperative(lst))

println(doubleFunctional(lst))









